{
   muu Library for TMT Pascal - Dither matrix tables
   Original C code Copyright (C) 1998 The Rasterman

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}

CONST DitherMatrix_44:   ARRAY[0..3,0..3] OF byte = ((0, 4, 1, 5),
                                                     (6, 2, 7, 3),
                                                     (1, 5, 0, 4),
                                                     (7, 3, 6, 2));

TYPE DitherTab8 =   ARRAY[0..3,0..3,0..255] OF byte;

     DitherTab16 =  ARRAY[0..3,0..3,0..255] OF word;

VAR DitherTab_r332_44:  DitherTab8;
    DitherTab_g332_44:  DitherTab8;
    DitherTab_b332_44:  DitherTab8;

    DitherTab_r565_44:  DitherTab16;
    DitherTab_g565_44:  DitherTab16;
    DitherTab_b565_44:  DitherTab16;
