{
   muu TrueColor library for TMT Pascal - Nova MMX clearer routines
   Copyright (C) 1999 Tor Arne Gustad (anden@online.no)

   This source code is licensed under the GNU Public License.
   See the GNU General Public License for more details.
}
PROCEDURE Nmmx_CLEAR_4BYTE(tgt:pointer;col,wdt,hgt,nl:dword); assembler;
ASM
    fwait   // make sure FPU isn't running

        // create filler
    mov  eax,  col
    mov  esi,  @@filler
    mov  [esi],  eax
    mov  [esi+4],  eax
    movq mm0,  [esi]

    mov  edi,  tgt
    mov  ebx,  hgt
    
@@line_loop:    
    mov  ecx,  wdt
    mov  edx,  wdt
    shr  ecx,  2
    jz   @@no_opt
    
@@move_opt:
    movq [edi],  mm0
    movq [edi+8],  mm0
    
    add  edi,  16
    dec  ecx
    jnz  @@move_opt

@@no_opt:
    and  edx,  15
    jz   @@no_comp
    
@@fill_comp:
    mov  [edi],  al
    ror  eax,  8
    inc  edi
    dec  edx
    jnz  @@fill_comp

@@no_comp:
    add  edi,  nl

    dec  ebx
    jnz  @@line_loop

    jmp  @@m_end

@@filler:
    dd  $000000
    dd  $000000
    dd  $000000
    dd  $000000

@@m_end:

    emms    // shut down MMX
END;
