FUNCTION Pack16; assembler;
ASM
    mov  eax,  pix32

    // ax = _____GGG GGGBBBBB
    shr  ah,   2
    shr  ax,   3

    // ah = RRRRRGGG
    mov  ebx,  eax
    shr  ebx,  8
    and  bh,   $F8
    or   ah,   bh

    mov  result,  ax
END;

FUNCTION Pack15; assembler;
ASM
    mov  eax,  pix32

    // ax = ______GG GGGBBBBB
    shr  ah,   3
    shr  ax,   3
    
    // ah = _RRRRRGG
    mov  ebx,  eax
    shr  ebx,  9
    and  bh,   $7C
    or   ah,   bh

    mov  result,  ax
END;

FUNCTION Pack8; assembler;
ASM
    mov  eax,  pix32
    shr  ah,   6
    shr  ax,   5

    mov  ebx,  eax
    shr  ebx,  16
    and  bl,   $E0
    or   al,   bl

    mov  result,  al
END;

FUNCTION Unpack16; assembler;
ASM
    // ax = RRRRRGGG GGGBBBBB, bl = GGGBBBBB
    mov  ax,   pix16
    mov  bl,   al

    // bl = BBBBB___
    shl  bl,   3

    // ax = RRRRR___ GGGGGG__
    shr  ax,   3
    shl  ah,   3
    and  ax,   $F8FC

    // eax = ________ RRRRR___ GGGGGG__ BBBBB___
    shl  eax,  8
    mov  al,   bl

    mov  result,  eax
END;

FUNCTION Unpack15; assembler;
ASM
    // ax = _RRRRRGG GGGBBBBB, bl = GGGBBBBB
    mov  ax,   pix15
    mov  bl,   al

    // bl = BBBBB___
    shl  bl,   3

    // ax = RRRRR___ GGGGG___
    shr  ax,   2
    shl  ah,   3
    and  ax,   $F8F8

    // eax = ________ RRRRR___ GGGGG___ BBBBB___
    shl  eax,  8
    mov  al,   bl

    mov  result,  eax
END;
